mib parsing and datatype manipulation routines.(3)

NAME
mib parsing and datatype manipulation routines. -

  Data Structures
struct _PrefixList
struct parse_hints

  Typedefs
typedef _PrefixList * PrefixListPtr
typedef _PrefixList PrefixList

  Functions
int sprint_realloc_hexstring (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const u_char *cp, size_t len)
Prints a hexadecimal string into a buffer.
int sprint_realloc_asciistring (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const u_char *cp, size_t len)
Prints an ascii string into a buffer.
int sprint_realloc_octet_string (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints an octet string into a buffer.
int sprint_realloc_counter64 (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a counter into a buffer.
int sprint_realloc_opaque (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints an object identifier into a buffer.
int sprint_realloc_object_identifier (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints an object identifier into a buffer.
int sprint_realloc_timeticks (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a timetick variable into a buffer.
int sprint_realloc_hinted_integer (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, long val, const char decimaltype, const char *hint, const char *units)
Prints an integer according to the hint into a buffer.
int sprint_realloc_integer (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints an integer into a buffer.
int sprint_realloc_uinteger (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints an unsigned integer into a buffer.
int sprint_realloc_gauge (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a gauge value into a buffer.
int sprint_realloc_counter (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a counter value into a buffer.
int sprint_realloc_networkaddress (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a network address into a buffer.
int sprint_realloc_ipaddress (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints an ip-address into a buffer.
int sprint_realloc_null (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a null value into a buffer.
int sprint_realloc_bitstring (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Prints a bit string into a buffer.
int sprint_realloc_nsapaddress (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int sprint_realloc_badtype (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Fallback routine for a bad type, prints 'Variable has bad type' into a buffer.
int sprint_realloc_by_type (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
Universal print routine, prints a variable into a buffer according to the variable type.
tree * get_tree_head (void)
Retrieves the tree head.
char * snmp_out_toggle_options (char *options)
void snmp_out_toggle_options_usage (const char *lead, FILE *outf)
char * snmp_in_toggle_options (char *options)
void snmp_in_toggle_options_usage (const char *lead, FILE *outf)
Prints out a help usage for the in* toggle options.
void register_mib_handlers (void)
void netsnmp_set_mib_directory (const char *dir)
char * netsnmp_get_mib_directory ()
set_string calls strdup, so if we allocated memory, free it.
void netsnmp_fixup_mib_directory ()
Not set use hard coded path.
void init_mib (void)
Initialises the mib reader.
void shutdown_mib (void)
Unloads all mibs.
void print_mib (FILE *fp)
Prints the MIBs to the file fp.
void print_ascii_dump (FILE *fp)
void set_function (struct tree *subtree)
Set's the printing function printomat in a subtree according it's type.
int read_objid (const char *input, oid *output, size_t *out_len)
Reads an object identifier from an input string into internal OID form.
tree * netsnmp_sprint_realloc_objid_tree (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, int *buf_overflow, const oid *objid, size_t objidlen)
int sprint_realloc_objid (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const oid *objid, size_t objidlen)
int snprint_objid (char *buf, size_t buf_len, const oid *objid, size_t objidlen)
void print_objid (const oid *objid, size_t objidlen)
Prints an oid to stdout.
void fprint_objid (FILE *f, const oid *objid, size_t objidlen)
Prints an oid to a file descriptor.
int sprint_realloc_variable (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
int snprint_variable (char *buf, size_t buf_len, const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
void print_variable (const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
Prints a variable to stdout.
void fprint_variable (FILE *f, const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
Prints a variable to a file descriptor.
int sprint_realloc_value (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
int snprint_value (char *buf, size_t buf_len, const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
void print_value (const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
void fprint_value (FILE *f, const oid *objid, size_t objidlen, netsnmp_variable_list *variable)
int build_oid_segment (netsnmp_variable_list *var)
Takes the value in VAR and turns it into an OID segment in var->name.
int build_oid_noalloc (oid *in, size_t in_len, size_t *out_len, oid *prefix, size_t prefix_len, netsnmp_variable_list *indexes)
int build_oid (oid **out, size_t *out_len, oid *prefix, size_t prefix_len, netsnmp_variable_list *indexes)
int parse_oid_indexes (oid *oidIndex, size_t oidLen, netsnmp_variable_list *data)
int parse_one_oid_index (oid **oidStart, size_t *oidLen, netsnmp_variable_list *data, int complete)
int dump_realloc_oid_to_string (const oid *objid, size_t objidlen, u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, char quotechar)
tree * get_tree (const oid *objid, size_t objidlen, struct tree *subtree)
Clone of get_symbol that doesn't take a buffer argument.
void print_description (oid *objid, size_t objidlen, int width)
Prints on oid description on stdout.
void fprint_description (FILE *f, oid *objid, size_t objidlen, int width)
Prints on oid description into a file descriptor.
int get_module_node (const char *fname, const char *module, oid *objid, size_t *objidlen)
int get_wild_node (const char *name, oid *objid, size_t *objidlen)
int get_node (const char *name, oid *objid, size_t *objidlen)
void clear_tree_flags (register struct tree *tp)
void print_oid_report (FILE *fp)
void print_oid_report_enable_labeledoid (void)
void print_oid_report_enable_oid (void)
void print_oid_report_enable_suffix (void)
void print_oid_report_enable_symbolic (void)
char * uptime_string (u_long timeticks, char *buf)
Converts timeticks to hours, minutes, seconds string.
oid * snmp_parse_oid (const char *argv, oid *root, size_t *rootlen)
const char * parse_octet_hint (const char *hint, const char *value, unsigned char **new_val, int *new_val_len)
u_char mib_to_asn_type (int mib_type)
int netsnmp_str2oid (const char *S, oid *O, int L)
Converts a string to its OID form.
int netsnmp_oid2chars (char *C, int L, const oid *O)
Converts an OID to its character form.
int netsnmp_oid2str (char *S, int L, oid *O)
Converts an OID to its string form.
int snprint_by_type (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_hexstring (char *buf, size_t buf_len, const u_char *cp, size_t len)
int snprint_asciistring (char *buf, size_t buf_len, const u_char *cp, size_t len)
int snprint_octet_string (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_opaque (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_object_identifier (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_timeticks (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_hinted_integer (char *buf, size_t buf_len, long val, const char *hint, const char *units)
int snprint_integer (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_uinteger (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_gauge (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_counter (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_networkaddress (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_ipaddress (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_null (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_bitstring (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_nsapaddress (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_counter64 (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)
int snprint_badtype (char *buf, size_t buf_len, netsnmp_variable_list *var, struct enum_list *enums, const char *hint, const char *units)

  Variables
tree * tree_head
tree * Mib
oid RFC1213_MIB [] = { 1, 3, 6, 1, 2, 1 }
PrefixList mib_prefixes []

FUNCTION DOCUMENTATION

  int build_oid_segment (netsnmp_variable_list * var)

Takes the value in VAR and turns it into an OID segment in var->name.

Parameters:

var The variable.

Returns:
SNMPERR_SUCCESS or SNMPERR_GENERR

Definition at line 3226 of file mib.c.

  void fprint_description (FILE * f, oid * objid, size_t objidlen, int width)

Prints on oid description into a file descriptor.

Parameters:

f   The file descriptor to print to.

objid
    The object identifier.

objidlen
    The object id length.

width
    Number of subidentifiers.

Definition at line 4079 of file mib.c.

  void fprint_objid (FILE * f, const oid * objid, size_t objidlen)

Prints an oid to a file descriptor.

Parameters:

f   The file descriptor to print to.

objid
    The oid to print

objidlen
    The length of oidid.

Definition at line 2967 of file mib.c.

  void fprint_variable (FILE * f, const oid * objid, size_t objidlen, netsnmp_variable_list * variable)

Prints a variable to a file descriptor.

Parameters:

f   The file descriptor to print to.

objid
    The object id.

objidlen
    The length of teh object id.

variable
    The variable to print.

Definition at line 3109 of file mib.c.

  struct tree* get_tree (const oid * objid, size_t objidlen, struct tree * subtree)

Clone of get_symbol that doesn't take a buffer argument.

See also:
get_symbol

Definition at line 4034 of file mib.c.

  struct tree* get_tree_head (void)

Retrieves the tree head.

Returns:
the tree head.

Definition at line 2021 of file mib.c.

  int get_wild_node (const char * name, oid * objid, size_t * objidlen)

See also:
comments on find_best_tree_node for usage after first time.

Definition at line 4941 of file mib.c.

  void init_mib (void)

Initialises the mib reader.

Reads in all settings from the environment.

Definition at line 2456 of file mib.c.

  void netsnmp_fixup_mib_directory ()

Not set use hard coded path.

Definition at line 2410 of file mib.c.

  char* netsnmp_get_mib_directory ()

set_string calls strdup, so if we allocated memory, free it.

Definition at line 2363 of file mib.c.

  int netsnmp_oid2chars (char * C, int L, const oid * O)

Converts an OID to its character form.

in example 5 . 1 . 2 . 3 . 4 . 5 = 12345

Parameters:

C   The character buffer.

L   The length of the buffer.

O   The oid.

Returns:
0 on Sucess, 1 on failure.

Definition at line 5635 of file mib.c.

  int netsnmp_oid2str (char * S, int L, oid * O)

Converts an OID to its string form.

in example 5 . 'h' . 'e' . 'l' . 'l' . 'o' = 'hello\0' (null terminated)

Parameters:

S   The character string buffer.

L   The length of the string buffer.

O   The oid.

Returns:
0 on Sucess, 1 on failure.

Definition at line 5663 of file mib.c.

  int netsnmp_str2oid (const char * S, oid * O, int L)

Converts a string to its OID form.

in example 'hello' = 5 . 'h' . 'e' . 'l' . 'l' . 'o'

Parameters:

S   The string.

O   The oid.

L   The length of the oid.

Returns:
0 on Sucess, 1 on failure.

Definition at line 5600 of file mib.c.

  void print_description (oid * objid, size_t objidlen, int width)

Prints on oid description on stdout.

See also:
fprint_description

Definition at line 4063 of file mib.c.

  void print_mib (FILE * fp)

Prints the MIBs to the file fp.

Parameters:

fp  The file descriptor to print to.

Definition at line 2636 of file mib.c.

  void print_objid (const oid * objid, size_t objidlen)

Prints an oid to stdout.

Parameters:

objid
    The oid to print

objidlen
    The length of oidid.

Definition at line 2953 of file mib.c.

  void print_variable (const oid * objid, size_t objidlen, netsnmp_variable_list * variable)

Prints a variable to stdout.

Parameters:

objid
    The object id.

objidlen
    The length of teh object id.

variable
    The variable to print.

Definition at line 3093 of file mib.c.

  int read_objid (const char * input, oid * output, size_t * out_len)

Reads an object identifier from an input string into internal OID form.

When called, out_len must hold the maximum length of the output array.

Parameters:

input
    the input string.

output
    the oid wirte.

out_len
    number of subid's in output.

Returns:
1 if successful.If an error occurs, this function returns 0 and MAY set snmp_errno. snmp_errno is NOT set if SET_SNMP_ERROR evaluates to nothing. This can make multi-threaded use a tiny bit more robust.

Definition at line 2732 of file mib.c.

  void set_function (struct tree * subtree)

Set's the printing function printomat in a subtree according it's type.

Parameters:

subtree
    The subtree to set.

Definition at line 2657 of file mib.c.

  void shutdown_mib (void)

Unloads all mibs.

Definition at line 2613 of file mib.c.

  void snmp_in_toggle_options_usage (const char * lead, FILE * outf)

Prints out a help usage for the in* toggle options.

Parameters:

lead
    The lead to print for every line.

outf
    The file descriptor to write to.

Definition at line 2229 of file mib.c.

  int sprint_realloc_asciistring (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const u_char * cp, size_t len)

Prints an ascii string into a buffer.

The characters pointed by *cp are encoded as an ascii string.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf address of the buffer to print to.

buf_len
    address to an integer containing the size of buf.

out_len
    incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

cp  the array of characters to encode.

len the array length of cp.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 343 of file mib.c.

  int sprint_realloc_badtype (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Fallback routine for a bad type, prints 'Variable has bad type' into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1907 of file mib.c.

  int sprint_realloc_bitstring (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a bit string into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1768 of file mib.c.

  int sprint_realloc_by_type (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Universal print routine, prints a variable into a buffer according to the variable type.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1942 of file mib.c.

  int sprint_realloc_counter (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a counter value into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1536 of file mib.c.

  int sprint_realloc_counter64 (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a counter into a buffer.

The variable var is encoded as a counter value.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 841 of file mib.c.

  int sprint_realloc_gauge (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a gauge value into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1463 of file mib.c.

  int sprint_realloc_hexstring (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const u_char * cp, size_t len)

Prints a hexadecimal string into a buffer.

The characters pointed by *cp are encoded as hexadecimal string.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf address of the buffer to print to.

buf_len
    address to an integer containing the size of buf.

out_len
    incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

cp  the array of characters to encode.

len the array length of cp.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 241 of file mib.c.

  int sprint_realloc_hinted_integer (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, long val, const char decimaltype, const char * hint, const char * units)

Prints an integer according to the hint into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may _NOT_ be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1189 of file mib.c.

  int sprint_realloc_integer (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints an integer into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1263 of file mib.c.

  int sprint_realloc_ipaddress (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints an ip-address into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1665 of file mib.c.

  int sprint_realloc_networkaddress (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a network address into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1599 of file mib.c.

  int sprint_realloc_null (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a null value into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1724 of file mib.c.

  int sprint_realloc_object_identifier (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints an object identifier into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1045 of file mib.c.

  int sprint_realloc_octet_string (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints an octet string into a buffer.

The variable var is encoded as octet string.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 403 of file mib.c.

  int sprint_realloc_opaque (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints an object identifier into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 955 of file mib.c.

  int sprint_realloc_timeticks (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints a timetick variable into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1115 of file mib.c.

  int sprint_realloc_uinteger (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, netsnmp_variable_list * var, struct enum_list * enums, const char * hint, const char * units)

Prints an unsigned integer into a buffer.

If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)

Parameters:

buf Address of the buffer to print to.

buf_len
    Address to an integer containing the size of buf.

out_len
    Incremented by the number of characters printed.

allow_realloc
    if not zero reallocate the buffer to fit the needed size.

var The variable to encode.

enums
    The enumeration ff this variable is enumerated. may be NULL.

hint
    Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL.

units
    Contents of the UNITS clause of the MIB. may be NULL.

Returns:
1 on success, or 0 on failure (out of memory, or buffer to small when not allowed to realloc.)

Definition at line 1366 of file mib.c.

  char* uptime_string (u_long timeticks, char * buf)

Converts timeticks to hours, minutes, seconds string.

CMU compatible does not show centiseconds.

Parameters:

timeticks
    The timeticks to convert.

buf Buffer to write to, has to be at least 64 Bytes large.

Returns:
The buffer

See also:
uptimeString

Definition at line 5223 of file mib.c.

VARIABLE DOCUMENTATION

  PrefixList mib_prefixes[]

Initial value:

 {
    {&Standard_Prefix[0]},
    {'.iso.org.dod.internet.mgmt.mib-2'},
    {'.iso.org.dod.internet.experimental'},
    {'.iso.org.dod.internet.private'},
    {'.iso.org.dod.internet.snmpParties'},
    {'.iso.org.dod.internet.snmpSecrets'},
    {NULL, 0}
}

Definition at line 138 of file mib.c.